﻿

var g_view = "day";
var g_DisplayDate = new IranianDate().toDateString();
var g_SelectMonth = 1;
var g_SelectYear = 1388;
var g_CalendarAlarm = null;

function init() {
    System.Gadget.Flyout.file = "DatePicker.html";

    System.Gadget.onDock = CheckDockState;
    System.Gadget.onUndock = CheckDockState;

    CalendarAlarm();
}

function CheckDockState() {
    if (System.Gadget.docked) {
        g_view = "day";
        DayView.className = "DayViewDocked";
        OtherView.className = "OtherViewDocked";

        with (document.body.style) {
            width = 130,
            height = 141,
            backgroundRepeat = "no-repeat";
        }
    }
    else {
        if (g_view == "day") g_view = "month";
        DayView.className = "DayViewUndocked";
        OtherView.className = "OtherViewUndocked";

        with (document.body.style) {
            width = 129;
            height = 264;
        }
    }

    UpdateView();
}

function SetBackground() {
    var path = "";
    var IsToday = g_DisplayDate == new IranianDate().toDateString();

    if (IsToday) {
        DayViewContainer.className = IsHoliday(g_DisplayDate) ? "DayViewTodayHoliday" : "DayViewToday";
        Curl.style.display = "none";
    }
    else {
        DayViewContainer.className = IsHoliday(g_DisplayDate) ? "DayViewNotTodayHoliday" : "DayViewNotToday";
        Curl.style.display = "";
    }

    if (System.Gadget.docked) {
        if (g_view == "day") {
            DayView.style.display = "";
            OtherView.style.display = "none";
        }
        else {
            DayView.style.display = "none";
            OtherView.style.display = "";
        }
        if (g_view == "day" && IsToday)
            path = "url(images/calendar_single_green.png)";
        else
            path = "url(images/calendar_single.png)"
    }
    else {
        DayView.style.display = "";
        OtherView.style.display = "";

        if (IsToday)
            path = "url(images/calendar_double_green.png)";
        else
            path = "url(images/calendar_double.png)";
    }

    CalendarBackground.style.width = 0;
    CalendarBackground.style.height = 0;
    CalendarBackground.src = SpecialBackgroundPath(path);
}

function UpdateView() {
    SetBackground();
    UpdateDayView();

    var selectDate = new IranianDate();
    selectDate.FullYear = g_SelectYear;
    selectDate.Month = g_SelectMonth;

    if (g_view == "month") {
        OtherViewNavTitle.innerText = selectDate.MonthNames[selectDate.Month] + " " + RepresentNumberInFarsi(selectDate.getYear());
        OtherViewContents.innerHTML = CreateMonthView();
    }
    else if (g_view == "year") {
        OtherViewNavTitle.innerText = RepresentNumberInFarsi(g_SelectYear);
        OtherViewContents.innerHTML = CreateYearView();
    }
}




function UpdateDayView() {
    d = new IranianDate(g_DisplayDate);

    DayViewDayOfWeek.innerHTML = d.DayOfWeekNames[d.getDay()];
    DayViewDate.innerHTML = RepresentNumberInFarsi(d.Date);
    DayViewMonthYear.innerHTML = d.MonthNames[d.Month] + " " + RepresentNumberInFarsi(d.getYear());

    DayViewContainer.title = DayComment(d.toDateString());
}

function CreateMonthView() {
    var s = "<div UNSELECTABLE='on' style='margin:-2 0 0 0'>";
    var cls = "", txt = "";
    var doc = LoadHolidayFile();

    var selectDate = new IranianDate();
    selectDate.FullYear = g_SelectYear;
    selectDate.Month = g_SelectMonth;
    selectDate.Date = 1;
    var d = -1 * selectDate.getDay();

    var lastMonth = new IranianDate();
    lastMonth.FullYear = g_SelectYear;
    lastMonth.Month = g_SelectMonth;
    if (g_SelectMonth) {
        lastMonth.Month--;
    }
    else {
        lastMonth.FullYear--;
        lastMonth.Month = 11;
    }
    var dlast = lastMonth.getMonthLength() + d;

    for (w = 0; w < 7; w++) {
        for (i = 0; i < 7; i++) {
            cls = i ? "border" : "";
            if (!w) {
                cls += " name";
                s += "<q class='" + cls + "'>" + selectDate.DayOfWeekNames[i].charAt(0) + "</q>";
            }
            else {
                var active = false;
                if (++d <= 0) {
                    cls += " dim";
                    txt = RepresentNumberInFarsi(++dlast);
                }
                else if (d <= selectDate.getMonthLength()) {
                    active = true;
                    selectDate.Date = d;
                    if (IsHoliday(selectDate.toDateString(), doc)) cls += " holiday";
                    if (selectDate.toDateString() == new IranianDate().toDateString()) cls += " today";
                    if (selectDate.toDateString() == new IranianDate(g_DisplayDate).toDateString()) cls += " select";
                    txt = RepresentNumberInFarsi(d);
                }
                else {
                    cls += " dim";
                    txt = RepresentNumberInFarsi(d - selectDate.getMonthLength());
                }

                if (active) {
                    s += "<q class='" + cls + "' onmouseover=\"className='hot '+className\" onmouseout=\"className=className.substr(4)\" onkeypress='NavigateToDay(" + d + ");' onclick='NavigateToDay(" + d + ")' title='" + DayComment(selectDate.toDateString(), doc) + "'>" + txt + "</q>";
                }
                else {
                    s += "<q class='" + cls + "'>" + txt + "</q>";
                }
            }
        }
        s += "<br />";
    }

    return s + "</div>";
}

function CreateYearView() {
    var s = "<div UNSELECTABLE='on' style='margin:5 4 0 0'>";
    var m = 0, y, x;
    var selectDate = new IranianDate();
    for (y = 0; y < 3; y++, s += "<br />") {
        for (x = 0; x < 4; x++) {
            m = x * 3 + y;
            s += "<var tabindex='" + (m + 1) + "' onmouseover=className='hot' onmouseout=className='' onkeypress='NavigateToMonth(" + m + ");' onclick='NavigateToMonth(" + m + ")'>" + selectDate.MonthNames[m] + "</var>";
        }
    }
    return s + "</div>";
}

function RepresentNumberInFarsi(num) {
    var s = new String(num);
    var out = "";

    for (var i = 0; i < s.length; i++) {
        out += String.fromCharCode(s.charCodeAt(i) + 1728);
    }

    return out;
}






function ToggleView() {
    var d = new IranianDate(g_DisplayDate);
    g_SelectMonth = d.getMonth();
    g_SelectYear = d.getFullYear();

    if (g_view == "day") {
        g_view = "month";
    }

    UpdateView();
}

function DoNavigate(val) {
    if (g_view == "month") {
        g_SelectMonth += val;
        if (g_SelectMonth == -1) {
            g_SelectMonth = 11;
            g_SelectYear--;
        }
        if (g_SelectMonth == 12) {
            g_SelectMonth = 0;
            g_SelectYear++;
        }
    }
    else if (g_view == "year") {
        g_SelectYear += val;
    }

    UpdateView();
}

function NavigateToMonth(val) {
    g_SelectMonth = val;
    g_view = "month";
    UpdateView();
}

function NavigateToDay(val) {
    var newDate = new IranianDate();
    newDate.FullYear = g_SelectYear;
    newDate.Month = g_SelectMonth;
    newDate.Date = val;
    g_DisplayDate = newDate.toDateString();

    if (System.Gadget.docked) {
        g_view = "day";
    }
    UpdateView();
}

function SwapNavigate() {
    if (g_view == "month") g_view = "year";
    else if (g_view == "year") g_view = "month";
    UpdateView();
}

function ShowExtras() {
    System.Gadget.Flyout.show = true;
}



function ShowToday() {
    var today = new IranianDate();
    g_DisplayDate = today.toDateString();
    g_SelectMonth = today.getMonth();
    g_SelectYear = today.getFullYear();
    if (System.Gadget.docked) g_view = "day";
    UpdateView();
}

function CalendarAlarm() {
    var now = new Date();
    var delta = 0;
    var hours = 0;
    var minutes = 0;
    var seconds = 0;
    var MilliSecondsPerDay = (24 * 60 * 60 * 1000);

    hours = now.getHours();
    minutes = now.getMinutes();
    seconds = now.getSeconds();

    delta = MilliSecondsPerDay - (hours * 60 * 60 * 1000) - (minutes * 60 * 1000) - (seconds * 1000);
    g_CalendarAlarm = setTimeout('CalendarAlarm()', delta);

    ShowToday();
}


