﻿var g_date = new Date();
var g_iranian = new IranianDate();


function init() {
    ListYears();
    ListMonths();
    ShowDates();
}

function ShowDates() {
    ListDates();

    IranianInputDate.value = g_iranian.getDate();
    IranianInputMonth.value = g_iranian.getMonth();
    IranianInputYear.value = g_iranian.getFullYear();
    IranianDayOfWeek.value = g_iranian.DayOfWeekNames[g_iranian.getDay()];

    GregorianInputDate.value = g_date.getDate();
    GregorianInputMonth.value = g_date.getMonth();
    GregorianInputYear.value = g_date.getFullYear();
    GregorianDayOfWeek.value = new Array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday")[g_date.getDay()];
}

function ReadDates() {
    g_iranian = new IranianDate(parseInt(IranianInputYear.value), parseInt(IranianInputMonth.value), parseInt(IranianInputDate.value));
    g_date = new Date(GregorianInputYear.value, GregorianInputMonth.value, GregorianInputDate.value);
    g_date.setDate(GregorianInputDate.value);
}

function InputChange(IsGregorian) {
    ReadDates();

    if (IsGregorian) {
        g_iranian = new IranianDate(g_date);
    }
    else {
        g_date = g_iranian.toDate();
    }

    ShowDates();
}

function ListYears() {
    for (var i = 1304; i < 1410; i++) {
        var opt = document.createElement("option");
        opt.value = i;
        opt.innerText = RepresentNumberInFarsi(i);
        IranianInputYear.appendChild(opt);
    }

    for (var i = 1925; i < 2031; i++) {
        var opt = document.createElement("option");
        opt.value = i;
        opt.innerText = i;
        GregorianInputYear.appendChild(opt);
    }
}

function ListMonths() {
    var d = new IranianDate();
    var m = Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");

    for (var i = 0; i < 12; i++) {
        var opt = document.createElement("option");
        opt.value = i;
        opt.innerText = d.MonthNames[i] + " (" + RepresentNumberInFarsi(i + 1) + ")";
        IranianInputMonth.appendChild(opt);

        opt = document.createElement("option");
        opt.value = i;
        opt.innerText = m[i] + " (" + (i + 1) + ")";
        GregorianInputMonth.appendChild(opt);
    }
}

function ListDates() {
    var max = g_iranian.getMonthLength();
    IranianInputDate.innerHTML = "";
    for (var i = 0; i < max; i++) {
        var opt = document.createElement("option");
        opt.innerText = RepresentNumberInFarsi(i + 1);
        opt.value = i + 1;
        IranianInputDate.appendChild(opt);
    }

    max = (new Date(g_date.getFullYear(), g_date.getMonth()+1, 0)).getDate();
    GregorianInputDate.innerHTML = "";
    for (var i = 0; i < max; i++) {
        var opt = document.createElement("option");
        opt.innerText = (i + 1).toString();
        opt.value = i + 1;
        GregorianInputDate.appendChild(opt);
    }
}

function RepresentNumberInFarsi(num) {
    var s = new String(num);
    var out = "";

    for (var i = 0; i < s.length; i++) {
        out += String.fromCharCode(s.charCodeAt(i) + 1728);
    }

    return out;
}

function RecoverNumberFromFarsi(num) {
    var s = new String(num);
    var out = "";

    for (var i = 0; i < s.length; i++) {
        if (s.charCodeAt(i) >= 1776 && s.charCodeAt(i) <= 1785)
            out += String.fromCharCode(s.charCodeAt(i) - 1728);
        else
            out += s.charAt(i);
    }

    return out;
}
